%bcond_without python3
%bcond_with    python2
%global forgeurl0 https://github.com/DNS-OARC/dnsperf

Summary: Benchmarking authorative and recursing DNS servers
Name: dnsperf
Version: 2.12.0
Release:    1%{?dist}

License: ASL 2.0
Url: https://www.dns-oarc.net/tools/dnsperf
Vcs: git:%{forgeurl0}

Source0: https://www.dns-oarc.net/files/dnsperf/%{name}-%{version}.tar.gz
Source2: dnsperf-data

BuildRequires: gcc, make
BuildRequires: autoconf automake libtool
BuildRequires: ldns-devel
BuildRequires: openssl-devel
BuildRequires: ck-devel
BuildRequires: libnghttp2-devel

%if %{with python3}
BuildRequires: python3-devel
%endif

%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Recommends: gnuplot
%else
Requires:   gnuplot
%endif
%if %{with python3}
BuildRequires: python3-devel
%endif

Provides: %{name}-data = %{version}-%{release}

%description
This is dnsperf, a collection of DNS server performance testing tools.
For more information, see the dnsperf(1) and resperf(1) man pages.

%if %{with python2} || %{with python3}
%package queryparse
Summary: Pcap dns query extraction utility
BuildArch: noarch
Requires: %{name} = %{version}-%{release}
%if %{with python3}
Requires: python3-pcapy python3-dns
%endif
%if %{with python2}
Requires: pcapy python2-dns
%endif

%description queryparse
This is dnsperf, a collection of DNS server performance testing tools.

Provides queryparse, python utility extracting queries from pcap files,
such as recorded by tcpdump or wireshark. Prints output in format
useable by dnsperf and resperf.

%endif

%prep
%autosetup -p1

%build
autoreconf -fi
%configure
%make_build

%if %{with python3}
%{__python3} /usr/bin/pathfix.py -i %{__python3} -p -n contrib/queryparse/queryparse
%endif

%install
%make_install dist_doc_DATA=''
%if %{with python2} || %{with python3}
install -p contrib/queryparse/queryparse %{buildroot}/%{_bindir}
install -D -m 644 -p contrib/queryparse/queryparse.1 %{buildroot}/%{_mandir}/man1/queryparse.1
gzip %{buildroot}/%{_mandir}/man1/queryparse.1
%endif

mkdir -p %{buildroot}%{_datadir}/%{name}
touch %{buildroot}%{_datadir}/%{name}/queryfile-example-current
install -m 755 -p %{SOURCE2} %{buildroot}%{_bindir}/dnsperf-data

%check
%make_build check

%files 
%doc README.md CHANGES
%license LICENSE
%{_bindir}/*perf*
%{_mandir}/man*/*perf*
%dir %{_datadir}/dnsperf
%ghost %{_datadir}/dnsperf/queryfile-example-current

%if %{with python2} || %{with python3}
%files queryparse
%{_bindir}/queryparse
%{_mandir}/man1/queryparse.1*
%endif

%changelog
* Wed Jul 31 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.12.0-1
- initial build
